#include <boost/iterator/iterator_adaptor.hpp>
#include <boost/iterator/iterator_traits.hpp>
#include <boost/type_traits/add_const.hpp>
#include <boost/type_traits/is_convertible.hpp>
#include <boost/utility/enable_if.hpp>

#include <atlbase.h>

#include <vector>

namespace ATL
{

template <typename T>
class CAdapt;

}

namespace test
{
namespace atl
{
namespace detail
{

template <typename T>
struct CAdapt_pointee { };

template <typename T>
struct CAdapt_pointee<ATL::CAdapt<T> >
{
	typedef T type;
};

template <typename Iterator, typename T>
struct m_T_type_add_const_conditionally
{
	typedef typename CAdapt_pointee<typename boost::iterator_value<Iterator>::type>::type type;
};

template <typename Iterator, typename T>
struct m_T_type_add_const_conditionally<Iterator, const T *>
{
	typedef typename boost::add_const<typename CAdapt_pointee<typename boost::iterator_value<Iterator>::type>::type>::type type;
};

template <typename T>
struct m_T_type
{
	typedef typename m_T_type_add_const_conditionally<T, typename boost::iterator_pointer<T>::type>::type type;
};

}

template <class Iterator>
class CAdapt_iterator : public
	boost::iterator_adaptor
	<
		CAdapt_iterator<Iterator>,
		Iterator,
		typename detail::m_T_type<Iterator>::type,
		typename boost::iterator_category<Iterator>::type,
		typename detail::m_T_type<Iterator>::type &
	>
{
private:
	struct enabler { };

public:
	CAdapt_iterator() { }
	CAdapt_iterator(Iterator p) : CAdapt_iterator::iterator_adaptor_(p) { }

	template <class OtherValue>
	CAdapt_iterator(const CAdapt_iterator<OtherValue> &other,
		typename boost::enable_if<boost::is_convertible<OtherValue *, Iterator *>, enabler>::type = enabler())
	:	CAdapt_iterator::iterator_adaptor_(other.base())
	{
	}

private:
	typedef typename detail::m_T_type<Iterator>::type &reference_type;

	friend class boost::iterator_core_access;

	reference_type dereference() const
	{
		return this->base()->m_T;
	}
};

template <typename Iterator>
CAdapt_iterator<Iterator> make_CAdapt_iterator(Iterator i)
{
	return CAdapt_iterator<Iterator>(i);
}

}
}

int main()
{
	std::vector<CAdapt<CComBSTR> > buffer(1, CComBSTR(L"Hello World!"));
	test::atl::make_CAdapt_iterator(buffer.begin())->Empty();
}
